# coding: utf-8

"""
    VeeRoute.LSS Routing

    Программный интерфейс для получения маршрутов и матриц расстояний  # noqa: E501

    The version of the OpenAPI document: 2.6.158615
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from vrt_lss_routing.configuration import Configuration


class Route(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'legs': 'list[RouteLeg]',
        'statistics': 'RouteStatistics'
    }

    attribute_map = {
        'legs': 'legs',
        'statistics': 'statistics'
    }

    def __init__(self, legs=None, statistics=None, local_vars_configuration=None):  # noqa: E501
        """Route - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._legs = None
        self._statistics = None
        self.discriminator = None

        if legs is not None:
            self.legs = legs
        self.statistics = statistics

    @property
    def legs(self):
        """Gets the legs of this Route.  # noqa: E501

        Отрезки маршрута между точками, указанными в параметре waypoints.  # noqa: E501

        :return: The legs of this Route.  # noqa: E501
        :rtype: list[RouteLeg]
        """
        return self._legs

    @legs.setter
    def legs(self, legs):
        """Sets the legs of this Route.

        Отрезки маршрута между точками, указанными в параметре waypoints.  # noqa: E501

        :param legs: The legs of this Route.  # noqa: E501
        :type: list[RouteLeg]
        """

        self._legs = legs

    @property
    def statistics(self):
        """Gets the statistics of this Route.  # noqa: E501


        :return: The statistics of this Route.  # noqa: E501
        :rtype: RouteStatistics
        """
        return self._statistics

    @statistics.setter
    def statistics(self, statistics):
        """Sets the statistics of this Route.


        :param statistics: The statistics of this Route.  # noqa: E501
        :type: RouteStatistics
        """

        self._statistics = statistics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Route):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Route):
            return True

        return self.to_dict() != other.to_dict()
